package me.captain.dnc;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import javax.persistence.PersistenceException;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.getspout.spoutapi.SpoutManager;
import org.getspout.spoutapi.player.AppearanceManager;
import org.getspout.spoutapi.player.SpoutPlayer;

public class DispNameChanger extends JavaPlugin
{
	public SpoutManager spout;
	public AppearanceManager am;
	public boolean useSpout;
	private final DPL playerlistener = new DPL(this);
	
	private static final Logger log = Logger.getLogger("Minecraft");
	private static DispNameChanger instance;
	
	private void setupDatabase()
	{
		try
		{
			getDatabase().find(DP.class).findRowCount();
		}
		catch (PersistenceException ex)
		{
			System.out.println(new StringBuilder()
					.append("Installing database for ")
					.append(getDescription().getName())
					.append(" due to first time usage").toString());
			
			installDDL();
		}
	}
	
	@SuppressWarnings(
	{ "unchecked", "rawtypes" })
	public List<Class<?>> getDatabaseClasses()
	{
		List list = new ArrayList();
		
		list.add(DP.class);
		
		return list;
	}
	
	public boolean canUseCheckName(Player p)
	{
		return p.hasPermission("dispname.check");
	}
	
	public boolean canUseChangeName(Player p)
	{
		return p.hasPermission("dispname.change");
	}
	
	public boolean canUseChangeNameSpace(Player p)
	{
		return p.hasPermission("dispname.changespace");
	}
	
	public boolean canUseChangeNameOther(Player p)
	{
		return p.hasPermission("dispname.changeother");
	}
	
	public static DispNameChanger getInstance()
	{
		return instance;
	}
	
	public boolean onCommand(CommandSender sender, Command cmd,
			String commandLabel, String[] args)
	{
		Player player = (Player) sender;
		
		if (commandLabel.equalsIgnoreCase("rename"))
		{
			if (canUseChangeName((Player) sender))
			{
				if (args.length == 0)
				{
					String rn = player.getName();
					player.setDisplayName(rn);
					player.sendMessage(new StringBuilder()
							.append(ChatColor.GREEN)
							.append("Your name is now ").append(rn).toString());
					return true;
				}
				
				int i = 0;
				
				StringBuilder builder = new StringBuilder();
				
				for (String s : args)
				{
					if (i >= 1)
					{
						builder.append(s);
						builder.append(" ");
					}
					i++;
				}
				
				String n = builder.toString();
				
				builder.substring(0, builder.length());
				
				String p = args[0];
				
				if (canUseChangeNameSpace((Player) sender))
				{
					if (n.endsWith(" "))
					{
						Integer index = Integer.valueOf(n.lastIndexOf(" "));
						String m = n;
						n = m.substring(0, index.intValue());
					}
					
				}
				else if (n.contains(" "))
				{
					Integer index = Integer.valueOf(n.indexOf(" "));
					String m = n;
					n = m.substring(0, index.intValue());
				}
				
				if (n.length() == 0)
				{
					Player changee = getServer().getPlayer(p);
					
					changee.setDisplayName(changee.getName());
					
					player.sendMessage(new StringBuilder()
							.append(ChatColor.GREEN).append(p)
							.append("'s name is now ")
							.append(changee.getName()).toString());
					
					return true;
				}
				
				Player changee = getServer().getPlayer(p);
				
				if (changee == null)
				{
					sender.sendMessage(new StringBuilder()
							.append(ChatColor.RED)
							.append("That user doesn't exist, or isn't online.")
							.toString());
				}
				else
				{
					Player changer = (Player) sender;
					
					if ((changer == changee)
							|| (canUseChangeNameOther((Player) sender)))
					{
						changee.setDisplayName(n.replaceAll("(&([a-f0-9]))",
								"$2"));
						
						changee.sendMessage(new StringBuilder()
								.append(ChatColor.GREEN)
								.append("Your name is now ").append(n)
								.toString());
						
						changer.sendMessage(new StringBuilder()
								.append(ChatColor.GREEN).append(p)
								.append("'s name is now ").append(n)
								.toString());
						
						DP pClass = (DP) getDatabase().find(DP.class).where()
								.ieq("PlayerName", p).findUnique();
						
						if (pClass == null)
						{
							pClass = new DP();
						}
						
						pClass.setPlayerName(p);
						
						pClass.setDisplayName(n);
						
						if (this.useSpout == true)
						{
							HumanEntity human = changee;
							
							SpoutPlayer splayer = (SpoutPlayer) player;
							
							if (splayer.isSpoutCraftEnabled())
							{
								splayer.sendNotification(
										new StringBuilder()
												.append(changee.getName())
												.append("'s name:").toString(),
										n.replaceAll("(&([a-f0-9]))", "$2"),
										Material.DIAMOND);
							}
							
							SpoutPlayer change = (SpoutPlayer) changee;
							
							if (change.isSpoutCraftEnabled())
							{
								change.sendNotification("Your name is:\t",
										n.replaceAll("(&([a-f0-9]))", "$2"),
										Material.DIAMOND);
							}
							
							this.am.setGlobalTitle(human,
									n.replaceAll("(&([a-f0-9]))", "$2"));
						}
						getDatabase().save(pClass);
					}
					else
					{
						Player s = (Player) sender;
						s.sendMessage(new StringBuilder()
								.append(ChatColor.RED)
								.append("You don't have permisson to change other players' names")
								.toString());
					}
				}
			}
			else
			{
				Player s = (Player) sender;
				s.sendMessage(new StringBuilder().append(ChatColor.RED)
						.append("You don't have permisson to change names")
						.toString());
			}
			return true;
		}
		if (commandLabel.equalsIgnoreCase("checkname"))
		{
			if (canUseCheckName((Player) sender))
			{
				String p = args[0];
				
				Player changee = getServer().getPlayer(p);
				
				String name = changee.getName();
				
				Player changer = (Player) sender;
				
				changer.sendMessage(new StringBuilder().append(ChatColor.RED)
						.append(p).append(" is really: ").append(name)
						.toString());
			}
			else
			{
				Player s = (Player) sender;
				s.sendMessage(new StringBuilder().append(ChatColor.RED)
						.append("You don't have permisson to check names")
						.toString());
			}
			
			return true;
		}
		
		return false;
	}
	
	public void onDisable()
	{
		log.info(new StringBuilder()
				.append("[DispNameChanger] DispNameChanger version ")
				.append(getDescription().getVersion())
				.append(" has been disabled!").toString());
	}

	public void onEnable()
	{
		PluginManager pm = getServer().getPluginManager();
		
		setupDatabase();
		
		pm.registerEvent(Event.Type.PLAYER_JOIN, this.playerlistener,
				Event.Priority.Normal, this);
		
		pm.registerEvent(Event.Type.PLAYER_QUIT, this.playerlistener,
				Event.Priority.Normal, this);
		
		Plugin Spout = pm.getPlugin("Spout");
		
		if (Spout == null)
		{
			this.useSpout = false;
			
			log.info("[DispNameChanger] Spout not detected! Not using spout features.");
		}
		else
		{
			this.useSpout = true;
			
			log.info(new StringBuilder()
					.append("[DispNameChanger] Spout detected! Using version ")
					.append(Spout.getDescription().getVersion()).append("!")
					.toString());
			
			this.am = SpoutManager.getAppearanceManager();
		}
		
		log.info(new StringBuilder().append("[DispNameChanger] Version ")
				.append(getDescription().getVersion()).append(" by ")
				.append(getDescription().getAuthors().toString())
				.append(" has been enabled!").toString());
	}
}